      SUBROUTINE MNA3R(F,A,B,C,EPS,XMIN,FMIN,IFLAG,ITMAX)
      INTEGER I,ITER,ITMAX,IFLAG
      REAL F,A,B,C,EPS,XMIN,FMIN,CGOLD,ZEPS,AX,BX,V,W,X,E,ZERO,FX,FV,
     *     FW,TOL1,TOL2,XM,R,Q,P,ETEMP,D,U,FU,CX
      COMMON/MNA3RR/ITER
      DATA CGOLD/0.3819660/,ZEPS/1.0E-10/,ZERO/0.0/
      IFLAG=0
      AX=A
      BX=B
      CX=C
      A=AMIN1(A,C)
      B=AMAX1(A,C)
      V=BX
      W=V
      X=V
      E=ZERO
      FX=F(X)
      FV=FX
      FW=FX
      DO 140 I=1,ITMAX
      ITER=I
      XM=0.5*(A+B)
      TOL1=EPS*ABS(X)+ZEPS
      TOL2=2.0*TOL1
      IF(ABS(X-XM).LE.(TOL2-0.5*(B-A))) GO TO 150
      IF(ABS(E).LE.TOL1) GO TO 10
      R=(X-W)*(FX-FV)
      Q=(X-V)*(FX-FW)
      P=(X-V)*Q-(X-W)*R
      Q=2.0*(Q-R)
      IF(Q.GT.ZERO) P=-P
      Q=ABS(Q)
      ETEMP=E
      E=D
      IF(ABS(P).GE.ABS(0.5*Q*ETEMP).OR.P.LE.Q*(A-X).OR.P.GE.Q*(B-X))
     *   GO TO 10
      D=P/Q
      U=X+D
      IF(U-A.LT.TOL2.OR.B-U.LT.TOL2) D=SIGN(TOL1,XM-X)
      GO TO 40
   10 IF(X.LT.XM) GO TO 20
      E=A-X
      GO TO 30
   20 E=B-X
   30 D=CGOLD*E
   40 IF(ABS(D).LT.TOL1) GO TO 50
      U=X+D
      GO TO 60
   50 U=X+SIGN(TOL1,D)
   60 FU=F(U)
      IF(FU.GT.FX) GO TO 90
      IF(U.LT.X) GO TO 70
      A=X
      GO TO 80
   70 B=X
   80 V=W
      FV=FW
      W=X
      FW=FX
      X=U
      FX=FU
      GO TO 110
   90 IF(U.GE.X) GO TO 100
      A=U
      GO TO 110
  100 B=U
  110 IF(FU.LE.FW.OR.W.EQ.X) GO TO 120
      IF(FU.LE.FV.OR.V.EQ.X.OR.V.EQ.W) GO TO 130
      GO TO 140
  120 V=W
      FV=FW
      W=U
      FW=FU
      GO TO 140
  130 V=U
      FV=FU
  140 CONTINUE
      GO TO 160
  150 IFLAG=1
  160 A=AX
      B=BX
      C=CX
      XMIN=X
      FMIN=FX
      RETURN
      END
